<?php

class Panel{
    var $str = array();
    var $png = array();
    var $headpng = '';
    
    var $logsPerPage = 50; // Number of logs per page
}

function getPanel($fb)
{
    $fb->panel = new Panel();
    
    getBodyHeader_str( $fb );
    
    $fb->panel->str['err'] = panelErr();
    
    $fb->dbHandle['account'] = $fb->account['name'];
    
    $fb->dbHandle['language'] = $fb->foundLanguage;
}

function pageView($str)
{
    global $fb; 
    if( has_get("action") && get("action") == $str ) { 
        $fb->panel->headpng = $str;
        return " <span style='color:#990012'> "; 
    }
    return " <span class='nav-list nav-header'>";
}

function GetAcc()
{
    $res = '';
    if( has_get("account") ) { $res = get("account"); }
    return $res;
}

function GetAct()
{
    $res = '';
    if( has_get("action") ) { $res = get("action"); }
    return $res;
}

function sortRef($sort)
{
    $res = "";//$res = "'>";
    if( has_get("action") && get("action") != "search") 
    { 
        $res .= "<a href='?action=".get("action")."&sort=".$sort."'>"; 
    }
    return $res;
}

function sort_order()
{
    if ($_SESSION["order"] == 0) {
        $srt = "ASC";
    }
    else {
        $srt = "DESC";
    }
    return $srt;
}

function fbc_sort_order()
{
    return $_SESSION["order"] ? "ASC" : "DESC";
}

function getUser()
{
    $res = '';
    if( isset($_SESSION["name"]) ) 
    { 
        $res = $_SESSION["name"]; 
    }
    return $res;
}

function getErr()
{
    $res = '';
    if( isset($_SESSION["err"]) && $_SESSION["permErr"] ) 
    { 
        $_SESSION["permErr"] = 0;
        $res = taskError($_SESSION["err"])."<ul></ul>"; 
    }
    return $res;
}

function getCountry($code) 
{
    global $fb;
    return $fb->panel->str['CountryName'][$code];
}

function getFlag($code)  
{
    global $fb;
    $flag = "script/img/flags/".strtolower($fb->panel->str['CountryCode'][$code]).".gif";        
    if( file_exists($flag) && is_readable($flag) )
    {
        return "<img src='".$flag."' width='24' height='16' alt='' />";
    }
    return "- - -";
}

function getOst($row)  
{
    $type = isset($row['ost']) ? $row['ost'] : '0';
    
    $ost = "script/img/misc/ost".$type.".png";        
    
    return "<img src='".$ost."' align='center' alt='' />";
}

function FBC_js()
{
    $ret = '';
    if( has_get("action") && get("action") == "fbconnect" )
    {
        $ret .= "<link rel='stylesheet' href='script/fbConnect/css/style_fbc.css?a6' type='text/css'>
            <script type='text/javascript' src='script/fbConnect/js/scripts.js?b9'></script>
            <script type='text/javascript' src='script/fbConnect/js/html_decoder.js'></script>";
    }    
    return $ret;
}

function TOS($fb)
{
    $title = $fb->panel->str['pageHead']["tos"];
    
    $tos = "<div align='center'> ...</div>";
    show($fb->panel->str['bodyHeader']."<h3>".$tos."</h3>".$fb->str['footer']."</div>", $title);exit();
}