<?php

function Screenshots( $fb )
{
    require_once 'fb_Logs.php';
    getFormLogs_str( $fb, get("action"));
    $fb->panel->str['bodyHeader'] .= $fb->panel->str["screenshotsDelete"];
    
    if( has_get("download") )
    {
        DownloadImage( $fb, get("download") );
    }
    
    if( has_get("view") )
    {
        $buffer = NULL;
        $fileStr = "script/screen/".get("view");
        
        if( file_exists($fileStr) ) {
            $buffer = file_get_contents( $fileStr );
        }
        
        if( $buffer )
        {
            $pPsw = base64_decode($fb->accountNumber);
            $cipher = new Crypt_RC4();
            $cipher->setKey($pPsw.get("view"));
        
            $base64 = $cipher->decrypt( $buffer );
    
            echo "<div align='center'> <img src='data:image/jpeg;base64,".$base64."' alt=''/></div>";
        }else { echo "<body><div align='center'><p><hr>Error: ".$fb->str['head_str']['noimage']."</div></p></body>"; }
        exit();
    }
    
    if( has_get("sort") ) { setSort(get("sort")); }
    ShowLog( $fb, get("action"), $fb->panel->str['keyhead']);
}

function DownloadImage($fb, $imName)
{
    $imgErr1 = " ".$fb->str['head_str']['noimage'];
    $imgErr2 = " ".$fb->str['head_str']['unimage'];
    
    if( !Perm(2) ) { header("Location: ".server('HTTP_REFERER')); exit(); }
    
    $fullPath = "script/screen/".$imName;
    
    if( !file_exists($fullPath) ) { $fb->panel->str['bodyHeader'] .= taskError($imgErr1); return 0; }
        
    $buffer = file_get_contents( $fullPath );
        
    if( !$buffer ) { $fb->panel->str['bodyHeader'] .= taskError($imgErr2); return 0; }
    
    $pPsw = base64_decode($fb->accountNumber);
    $cipher = new Crypt_RC4();
    $cipher->setKey($pPsw.$imName);
    
    $base64 = $cipher->decrypt( $buffer );
        
    header("Content-Disposition: attachment; filename=\"".$imName.".jpeg\"");
    header("Content-Type: application/force-download");
    
    echo base64_decode($base64); exit();/////*/
}

function DeleteImage($fb, $dbname, $selArray)
{
    $result = select_id_list($fb, $dbname, $selArray);
    
    if($result)
    {
        while ($row = mysqli_fetch_array($result)) 
        {
            $fullPath = "script/screen/".$row["content"];
            if( file_exists($fullPath) ) { unlink($fullPath); }
        }
    }
}

/*///////
    $fsize = filesize($fullPath);
    header("Pragma: public");
    header("Expires: 0");
    header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
    header("Cache-Control: private",false);
    header("Content-Type: image/jpeg");
    header("Content-Disposition: attachment; filename=\"".basename($imName).".jpeg\";" );
    header("Content-Transfer-Encoding: binary");
    header("Content-Length: ".$fsize);
    ob_clean();
    flush();///////*/