<?php
//CPMANAGER ///////////////////////////////////////////////////////////////////
function userManager($fb)
{
    $png = getPNGs();
    getUserManager_str($png, $fb);
    $p_str = &$fb->panel->str;
    $title = $fb->panel->str['pageHead']['usermanager'];
    
    $btn = array("user","deleteuser","password");
    $instance = "user";$img = $png['adduser'];
    
    if( (has_get("type") && get("type") == 'password') )  { 
        $instance = "password";$img = $png['changepassword'];
    }
    else if( (has_get("type") && get("type") == 'deleteuser') )  { 
        $instance = "deleteuser";$img = $png['deleteuser'];
    }

    $html = topButtonCp($fb, $btn, $instance)."<p>".$img."</p>";
    $cp = TableCp($fb, $instance);
    
    show($p_str['bodyHeader'].$html.$p_str['cpError'].$cp.$fb->str['footer']."</div>", $title);
}

function topButtonCp($fb, $btn, $inst)
{
    $redBtn = "<span class='btn' style='color:#996666'>";
    $sBtn = "<span class='well' style='color:#990012'>";
    
    for ($i = 0; $i < count($btn); $i++)
    {
        if( $btn[$i] == $inst)
        {
            $btn[$i] = $sBtn;
        }else{ $btn[$i] = $redBtn; }
    }
    
    $pt = "<li><a href='?action=usermanager&type=";
    return $html = "<ul class='nav nav-tabs'>
            ".$pt."user'>".$btn[0].$fb->panel->str['misc']['adduser']."</span></a></li>
            ".$pt."deleteuser'>".$btn[1].$fb->panel->str['misc']['deleteuser']."</span></a></li>
            ".$pt."password'>".$btn[2].$fb->panel->str['misc']['changepass']."</span></a></li>
            </ul> ";
}

function TableCp($fb, $Type)
{
    if( $Type == 'user') { 
        return addUser($fb);
    }
    elseif( $Type == 'deleteuser')
    {
        return DeleteUser($fb);
    }
    else { return ChangePass($fb); }
}

function ChangePass($fb)
{
    $ChangePass = $fb->panel->str['ChangePass'];
    $p_str = $fb->panel->str;
    $cpError = &$fb->panel->str['cpError'];
    
    if( has_post("act") && post("act") == "setPass" )
    {
        if( has_post("oldpass") && has_post("newpass") && (post("oldpass") != "") && 
                (post("newpass") != "") && (post("newpass") == post("confirmpass")) )
        {
            if( !isset($_SESSION["privilege"]) || $_SESSION["privilege"] < 3 ) {
                $cpError = taskError($p_str['err']['permission_err']); return $ChangePass."</form>"; }
            
            $passDb = "cred"; $accType = "account"; $accName = $fb->account['name'];
            if( $_SESSION["name"] != $fb->account['user'] ) {
            $passDb = "users"; $accType = "user"; $accName = $_SESSION["name"]; }
            
            $update = "UPDATE ".$passDb." SET password='".sha1(post("newpass"))."' WHERE ".$accType."='".$accName."';";
            
            $row = 0;
            $cred_result = mysqli_query($fb->mysql, "SELECT * FROM ".$passDb." WHERE ".$accType." ='".$accName."';");
            if( $cred_result )
            {
                $row = mysqli_fetch_array($cred_result);
            }
            
            if( !$row || (sha1(post("oldpass")) != $row["password"]) )
            {
                $cpError = taskError($p_str['err']['cperr7']);
                return $ChangePass.$p_str['setPassWrong'];
            }
            
            if( !mysqli_query($fb->mysql,$update) )
            {
                return $ChangePass.$p_str['setPassErr'];
            }
            
            $cpError = taskSuccess($p_str['err']['cperr6']);
            return $ChangePass."</form>";
        }
        else { $cpError = taskError($p_str['err']['cperr1']); return $ChangePass.$p_str['setPassWrong']; }
    }
    return $ChangePass."</form>";
}

function addUser($fb)
{
    $p_str = $fb->panel->str;
    $AddUser = $fb->panel->str['AddUser'];
    $cpError = &$fb->panel->str['cpError'];
    
    if( has_post("act") && post("act") == "addUser" )
    {
        if( has_post("username") && has_post("password") && (post("username") != "") && 
                (post("password") != "") && (post("password") == post("confirmpass")) )
        {
            $priv = getPrivilege();
            $user = filter_user(post("username")); $pass = post("password");
            $err = $fb->str['head_str']['username']." ".$user." ".$p_str['err']['exist'];
            if(empty($user)){ $cpError = taskError($p_str['err']['cperr1']); return $AddUser; }
            
            if( !isset($_SESSION["privilege"]) || $_SESSION["privilege"] < 3 ) { 
                $cpError = taskError($p_str['err']['permission_err']); return $AddUser; }
            
            $result = mysqli_query($fb->mysql, "SELECT * FROM users WHERE `user` = '".$user."';");
            
            if(!$result) {
                $cpError = taskError($p_str['err']['cperr']); return $AddUser;
            }
            if( $fb->account['user'] == $user || mysqli_num_rows($result) ) 
            {
                $cpError = taskError($err); return $AddUser;
            }
            
            $Query = "INSERT INTO `users` (`user`, `password`, `privilege`, `logtime`) 
                        VALUES ('".$user."','".sha1($pass)."','".$priv."','".date("Y-m-d H:i:s")."');";
            if ( mysqli_query($fb->mysql, $Query) )
            {
                $cpError = taskSuccess($p_str['err']['cperr2']);  return $AddUser;
            }
            
            $cpError = taskError($p_str['err']['cperr']); return $AddUser;
        }
        else { $cpError = taskError($p_str['err']['cperr1']); return $AddUser; }
    }
    return $AddUser;
}

function DeleteUser($fb)
{
    $DeleteUser = $fb->panel->str['DeleteUser'];
    $p_str = $fb->panel->str;
    $cpError = &$fb->panel->str['cpError'];
    
    if( has_post("act") && post("act") == "deleteUser" )
    {
        if( has_post("username") && has_post("password") && (post("username") != "") && 
                (post("password") != "") )
        {
            if( !isset($_SESSION["privilege"]) || $_SESSION["privilege"] < 3 ) { 
                $cpError = taskError($p_str['err']['cperr3']); return $DeleteUser."</form>"; }
                
            $user = post("username"); $pass = post("password");
            if(empty($user)){ $cpError = taskError($p_str['err']['cperr1']); return $DeleteUser.$p_str['setPassWrong']; }
                
            if( $fb->account['user'] == $user ) 
            {
                $cpError = taskError($p_str['err']['cperr3']); return $DeleteUser."</form>";
            }
            
            $result = mysqli_query($fb->mysql, "SELECT * FROM users WHERE `user` = '".$user."';");
            if( !$result || !($row = mysqli_fetch_array($result)) || sha1($pass) != $row["password"]) 
            {
                $cpError = taskError($p_str['err']['cperr5']); return $DeleteUser."</form>";
            }
            
            if( !mysqli_query($fb->mysql, "DELETE FROM users WHERE `user` = '".$user."';") )
            {
                $cpError = taskError($p_str['err']['cperr5']); return $DeleteUser."</form>";
            }
            
            $cpError = taskSuccess($p_str['err']['cperr4']); return $DeleteUser."</form>";
        }
        else { $cpError = taskError($p_str['err']['cperr1']); return $DeleteUser.$p_str['setPassWrong']; }
    }
    return $DeleteUser."</form>";
}

function getPrivilege()
{
    $users = Array("Guest","Normal","Admin");
    for($i = 0; $i < count($users); $i++)
    {
        if( has_post($users[$i]) && post($users[$i]) == true ){ return $i+1; }
    }
    return 0;
}