<?php

function fbc_rename($fb)
{
    $name = ''; $row = NULL;
    $id = has_get('num') ? get('num') : '';
    if(empty($id)){ fbcError($fb, $fb->fbc->err['11']); return; }
    
    $fileResult = mysqli_query($fb->mysql, "SELECT * FROM fbc_files WHERE `id` = '".$id."' LIMIT 1;");
    if( !$fileResult || !mysqli_num_rows($fileResult) || !($row = mysqli_fetch_array($fileResult)) ) 
    { 
        fbcError($fb, $fb->fbc->err['11']); return;
    }
    
    if( $row['file_type'] == 2 )
    {
        $name = has_post($id.'_text') ? filter_filename(post($id.'_text')) : '';
    }
    else { $name = has_post($id.'_text') ? filter_foldername(post($id.'_text')) : ''; }
    
    if(empty($name)){ fbcError($fb, $fb->fbc->err['11']); return; }
    
    $ext = pathinfo($name, PATHINFO_EXTENSION);
    if(!empty($ext)) 
    { 
        $name = substr( $name,0,strlen($name)-(strlen($ext)+1) ); 
        $ext = "', file_ext='".$ext;
    }else { $ext = '';}
    if(empty($name)){ $name = $ext; $ext = '0';}
    
    $url = "script/".$row['file_dir']."/".$row['file_name'];
    if( !file_exists($url) || !is_readable($url) ){ 
        fbcError($fb, $fb->fbc->err['13']); return false;
    }
            
    $newurl = "script/".$row['file_dir']."/".$name;
    if( file_exists($newurl) && is_readable($newurl) ){ 
        fbcError($fb, $fb->fbc->err['12']); return false;
    }
            
    if( !rename($url, $newurl) ){ 
        fbcError($fb, $fb->fbc->err['11']); return false;
    }
            
    $update = "UPDATE fbc_files SET file_name='".$name.$ext."' WHERE id='".$id."';";
    mysqli_query($fb->mysql,$update);
            
    if( $row['file_type'] == 1 )
    {
        fbc_dir_rename($fb, $row, $name);
    }
}

function fbc_dir_rename($fb, $dir_row, $newName)
{
    $row = NULL;
    $dir = $dir_row['file_dir']."/".$dir_row['file_name'];
    
    $fileResult = mysqli_query($fb->mysql, "SELECT * FROM fbc_files WHERE `file_dir` = '".
            $dir."' AND `file_type` = '0' LIMIT 1;");
    
    if( !$fileResult || !mysqli_num_rows($fileResult) || !($row = mysqli_fetch_array($fileResult)) ) 
    { 
        fbcError($fb, $fb->fbc->err['11']); return;
    }
    
    $update = "UPDATE fbc_files SET file_name='".$newName."',file_dir='".
            $dir_row['file_dir']."/".$newName."' WHERE id='".$row['id']."';";
    mysqli_query($fb->mysql,$update);
    
    $Result = mysqli_query($fb->mysql, "SELECT * FROM fbc_files");
    
    while($row = mysqli_fetch_array($Result))
    {
        if( !substr_compare($row['file_dir'], $dir, 0, strlen($dir)) )
        {
            $newDir = $dir_row['file_dir']."/".$newName.substr($row['file_dir'],strlen($dir));
            $update = "UPDATE fbc_files SET file_dir='".$newDir."' WHERE id='".$row['id']."';";
            mysqli_query($fb->mysql,$update);
        }
    }
}