/* FormBook */
function h_show(str, tp)
{
    var id = document.getElementById("h_text");
    var status = document.getElementById("status");
    var content = document.getElementById("menu_txt_diplay");
    
    if( status.value !== tp )
    { 
        if ( id && id !== undefined ){
            if(id.value === "") {
                document.getElementById("menu_"+status.value+"_diplay").innerHTML = "";
                status.value = 0;
            }
        }
    }
    
    if ( content !== undefined ){
        content.innerHTML = str;
    }
}

function h_hide() {
    var content = document.getElementById("menu_txt_diplay");
    
    if ( content !== undefined )
    {
        content.innerHTML = "";
    }
}

function h_act(str, tp)
{
    var status = document.getElementById("status");
    var content = document.getElementById("menu_"+tp+"_diplay");
    var old = document.getElementById("menu_"+status.value+"_diplay");
    
    if(tp === '1') {
        status.value = tp;
        return document.getElementById("head_action").submit();
    }
    
    if(tp === status.value) { return; }
    
    if ( old && old !== undefined ) { old.innerHTML = ""; }
    
    if ( content && content !== undefined )
    {
        var fileUpload = '';
        var overwrite = "&emsp;<input type='checkbox' name='overwrite' value='0'>Overwrite if existing?&emsp;";
        var bt = "<input type='text' name='h_text' id='h_text' style='margin-bottom:0px;' class='input-large'>";
        if(tp === '4') { fileUpload = "<input type='file' name='fileToUpload' id='h_text'>"; bt='';}
        if(tp === '2' || tp === '3') { overwrite = ''; }
        
        content.innerHTML = bt+fileUpload+overwrite+"<input type='submit' value='"+str+"' name='h_act'>";
    }
    if ( status !== undefined ) { status.value = tp; }
}

function check_hdact()
{
    var status = document.getElementById("status");
    var txt = document.getElementById("h_text");
    
    if(status.value && status.value !== '1') 
    {
        if(!txt || txt === undefined || txt.value === "") { return false; }
    }
    
    if(status.value === '4' || status.value === '5') 
    { 
        var uploading = document.getElementById("menu_uploading");
        if(uploading || uploading !== undefined) 
        { 
            if( (status.value === '4') && (txt.files !== undefined) && txt.files[0].size > 2048000 )
            {
                alert("Unable to upload file bigger than 2mb");
                return false;
            }
            else 
            { 
                uploading.innerHTML = 
                "<img src='script/fbConnect/img/uploading.gif?' align='center' alt=''>"; 
            }
        }
    }
    return true;
}

function s_on(hnd){
    if( hnd.value === 'Search') { hnd.value = '';}
}

function s_out(hnd){
    if(hnd.value === '') { hnd.value = 'Search';}
}

function check_search(hnd){
    var val = hnd.search_word.value;
    if (val === "" || val === "Search") {
	return false; }
    return true;
}

function fbc_fileDownload(id, check)
{
    var chk = document.getElementsByName('sel[]');
    chk[check].checked = true;
    
    var sel = document.getElementById('selection_form');
    if ( sel && sel !== undefined )
    {
        sel.action = "?action=fbconnect&act=download&num="+id;
    }
}

function fbc_remote_fileDownload(id)
{
    return false;
}

function fbc_rename(id)
{
    var handle = document.getElementById("menu"+id+"rename");
    
    if ( handle && handle !== undefined )
    {
        var txt = document.getElementById(id+"_text");
        if ( !txt || txt === undefined )
        {
            var fm = "</form><form action='?action=fbconnect&act=rename&num="+id+
                    "' method='post' onsubmit='if(!check_rename("+id+")) return false;'>";
            var tx = "<input type='text' name='"+id+"_text' id='"+id+"_text' style='margin-bottom:0px;' class='input-large'>";
            var bt = "<input type='submit' value='rename' name='rename'>";
            handle.innerHTML = fm+tx+bt;
        }
    }
}

function check_rename(id)
{
    var chk = document.getElementsByName('sel[]');
    var txt = document.getElementById(id+"_text");
    var sel = document.getElementById('selection_form');
  
    if(txt.value === "")
    {
        return false;
    }
    
    chk[0].checked = true;
    if ( sel && sel !== undefined )
    {
        sel.action = "?action=fbconnect&act=download&num="+id;
    }
    return true;
}

function fbcDelete(str1,str2)
{
    if ( confirmSelect(str1) === true )
    {
        if(!confirm(str2)){ return false; }
      
        var sel = document.getElementById('selection_form');
        if ( sel && sel !== undefined )
        {
            sel.action = "?action=fbconnect&act=delete";
        }return true;
    }
    
    return false;
}

function u_checkAll() 
{
    chk = document.getElementsByName('u_sel[]');
    mark = document.getElementById("u_check_all");
     
    for (i = 0; i<chk.length; i++) {
        if ( mark.checked === true ) {
            chk[i].checked = true;
        } 
        else {
            chk[i].checked = false;
        }
    }
}

function u_confirmSelect( str )
{
    chk = document.getElementsByName('u_sel[]');
    for (i = 0; i<chk.length; i++) { 
        if (chk[i].checked === true) { 
            return true;
        }
    }
    alert(str);
    return false;
}

function fbcXML()
{
    if (window.XMLHttpRequest)//IE7+
    {
        return new XMLHttpRequest();
    }
    else //IE6, IE5
    {
        return  ActiveXObject('Microsoft.XMLHTTP');
    }
}

function fbcGetText( xhttp, display, name_str , type)
{
    xhttp.onreadystatechange = function()
    {
        if(xhttp.readyState === 4 && xhttp.status === 200)
        {
            if( xhttp.responseText !== "" && type === 1)
            { 
                display.innerHTML = xhttp.responseText; 
            }
            else if ( xhttp.responseText !== "")
            {
                display.dataset.long = xhttp.responseText; 
            }
        }
    };
    xhttp.open("GET", "script/users/"+name_str+"?rand="+Math.random(), true );
    xhttp.send();
}

function userFileList( xhttp, id )
{
    var dir = document.getElementById("dir_"+id);
    if( !dir || dir === undefined){ return 0; }
    
    dir.dataset.long = '<img src="script/fbConnect/img/loading.gif" align="center" alt="">';
    fbcGetText(xhttp, dir, id+"f.txt", 0);
}

function testFileList( xhttp, id )
{
    var dir = document.getElementById("dir_"+id);
    if( !dir || dir === undefined){ return 0; }
    
    var loading = "script/fbConnect/img/loading.gif";
    if( dir.dataset.long.indexOf(loading) !== -1 || dir.dataset.long === "" )
    {
        fbcGetText(xhttp, dir, id+"f.txt", 0);
    }
}

function fbcGetWindow( xhttp, id )
{
    var win_div = document.getElementById("w_"+id);
    if( !win_div || win_div === undefined){ return; }
    
    fbcGetText( xhttp, win_div, id+"w.txt", 1);
}

function showFilesClick(id)
{
    var content = document.getElementById(id);
    var arrow = document.getElementById("arrow_"+id);
    
    var r_img = ".png' align='center' alt=''>";
    var l_img = "<img src='script/fbConnect/img/";
    if ( content !== undefined )
    {
        if( content.value === 0 || content.value === undefined)
        {
            content.value = 1;
            content.innerHTML = content.dataset.long;
            arrow.innerHTML = l_img+"fup"+r_img;
        }
        else if( content.value === 1 )
        {
            content.value = 0;
            content.innerHTML = "";
            arrow.innerHTML = l_img+"fdown"+r_img;
        }
    }
}